 char ot,pvr;
char ipb,sim,prm;
 unsigned int adc_rd,d1,d2,d3,d4;
int pv1,pv2,e;
char pwm1,pwm2,aa,prb1,prb2;

//PINES DE LOS SERVOS
sbit servo1 at portc.b3;
sbit servo2 at portc.b4;
sbit servo3 at portc.b0;
sbit servo4 at portb.b7;
sbit servo5 at portb.b7;
sbit servo6 at portb.b7;
sbit servo7 at portb.b7;
sbit servo8 at portb.b7;      //pueden ir a cualquier pin

sbit servo1_direction at trisc.b3;
sbit servo2_direction at trisc.b4;
sbit servo3_direction at trisc.b0;
sbit servo4_direction at trisb.b7;
sbit servo5_direction at trisb.b7;
sbit servo6_direction at trisb.b7;
sbit servo7_direction at trisb.b7;
sbit servo8_direction at trisb.b7;
  void interrupt()//
  {
  servos_interrupcion();

}

void simv()
{
  if(sim == 0)
  prm = 0b00111111; // 0
  if(sim == 1)
  prm = 0b00000110; // 1
  if(sim == 2)
  prm =0b01011011; // 2
   if(sim == 3)
  prm =0b01001111; // 3
  if(sim == 4)
  prm =0b01100110; // 4
  if(sim == 5)
  prm =0b01101101; // 5
  if(sim == 6)
  prm =0b01111101; // 6
  if(sim == 7)
  prm =0b00000111; // 7
  if(sim == 8)
  prm =0b01111111; // 8
  if(sim == 9)
  prm =0b01101111; // 9
  /*0b01110111, // A
  0b01111100, // B
  0b00111001, // C
  0b01011110, // D
  0b01111001, // E
  0b01110001  // F
  */
 }

void send(char dat)
{

      for (ot = 0; ot < 8 ; ot++)
     {
      LATB.B2 = 0; //SCLK
      if(dat & 1)
       {
        LATB.B1 = 1; //DIN
       }
       else
       {
        LATB.B1 = 0; //DIN
       }
       dat >>= 1;
       LATB.B2 = 1; //SCLK
     }
}
void sendCommand(char cmn)
 {
 LATB.B1 = 0; //DIN
 send(cmn);
 LATB.B1 = 1; //DIN
 }
 void sendData(char adr,char dat)
 {
   sendCommand(0x44);
   LATB.B1 = 0; //DIN
   send(0xC0 | adr);
   send(dat);
   LATB.B1 = 1; //DIN

 }
 void sendChar(char pos,char dat,char dot)
 {
    sendData(pos, dat | (dot ? 0b10000000 : 0));
    LATB.B1 = 0; //DIN
    LATB.B2 = 0; //SCLK
    LATB.B2 = 1; //SCLK
    LATB.B1 = 1; //DIN
 }
 void inid(char activateDisplay,char intensity)
 {
  LATB.B1 = 1; //DIN
  LATB.B2 = 1; //SCLK
  sendCommand(0x40);
  sendCommand(0x80 | (activateDisplay ? 8 : 0) | min(4, intensity));
  LATB.B1 = 0; //DIN
  send(0xC0);
  for (ipb = 0; ipb < 16; ipb++)
  {
    send(0x00);
  }
  LATB.B1 = 1; //DIN
 }
 void otobr(long tlong)
{
    sim = (tlong / 1000)%10;;
    simv();
    sendChar(3,prm,0);
    sim = (tlong / 100)%10;;
    simv();
    sendChar(2,prm,0);
    sim = (tlong / 10)%10;;
    simv();
    sendChar(1,prm,0);
    sim = tlong %10;;
    simv();
    sendChar(0,prm,0);
}


void main() 
{
       OSCCON.IRCF0 = 1;
       OSCCON.IRCF1 = 1;
       OSCCON.IRCF2 = 1; //
      //OSCCON = 0b01110000;
      // OSCCON.SCS1 = 0;
    //  OSCCON.SCS0 = 0;
     //  OSCTUNE.PLLEN = 1;
      // Delay_ms(10);
     //  OSCCON2.PLLRDY = 1;
     ANSELA = 0b00000001;
     ANSELB = 0b00000001;                        // Configure AN pins as digital I/O
     ANSELC = 0;
    LATA  = 0;
    LATB  = 0;
    LATC  = 0;
    TRISA = 0b00111111;
    TRISB = 0b01111001;
    TRISC = 0b00100000;
    PWM1_Init(1000);         //  PWM1    5 
    PWM2_Init(1000);         //  PWM2    5 
   PWM1_Start();            //   PWM1
   PWM2_Start();            //   PWM2
   PWM1_Set_Duty(0);      //     PWM1
   PWM2_Set_Duty(0);      //     PWM2
    LATA.B7 = 0; //1(A) vper(0) naz (1)
    LATA.B6 = 0; //2(B) vper(0) naz (1)
    init_servos(0.5,2.5);
    GIE_bit=1;
    servo_valor(1,30);//left servo 30 open 0 close
    servo_valor(2,-20); //centrol servo 0 up  80 down
    servo_valor(3,30);//Right servo 30 open 80 close
        aa=3;
       inid(1,4);
        /* while(1)
       {
         if(PORTB.B3 == 0)
        {
        servo_valor(1,0);//left servo 30 open 0 close
         servo_valor(3,80);//Right servo 30 open 80 close
        }
         if(PORTB.B4 == 0)
        {
         servo_valor(1,30);//left servo 30 open 0 close
         servo_valor(3,30);//Right servo 30 open 80 close
        }
          if(PORTB.B5 == 0)
        {
         servo_valor(2,-20);
        }
           if(PORTB.B6 == 0)
        {
         servo_valor(2,80);
        }
       } */
       
       //PORTC.B5 - Peredni datchik
       while(1)
       {
       if(aa == 3)otobr(ADC_read(12));
       if(aa == 0)otobr(ADC_read(0));
       if(aa == 1)otobr(PORTA.B1);
       if(aa == 2)otobr(PORTA.B2);
        if(PORTB.B3 == 0)
        {
        aa=0;

        }
          if(PORTB.B4 == 0)
        {
        aa=1;

        }
          if(PORTB.B5 == 0)
        {
        aa=2;

        }
          if(PORTB.B6 == 0)
        {

        break;
        }
        Delay_ms(30);
       }

      while(1)
      {
       if(ADC_read(0)<200)
       {
     PWM1_Set_Duty(255);      //     PWM1
     PWM2_Set_Duty(255);      //     PWM2
     LATA.B7 = 0; //1(A) vper(0) naz (1)
     LATA.B6 = 0; //2(B) vper(0) naz (1)
     }
     else
     {
       PWM1_Set_Duty(255);      //     PWM1
       PWM2_Set_Duty(255);      //     PWM2
     LATA.B7 = 0; //1(A) vper(0) naz (1)
     LATA.B6 = 1; //2(B) vper(0) naz (1)
     Delay_ms(200);
     }
     }
}